; TO BE COMPILED WITH SJASMPLUS

            org         $2000                       
            output      BETADISK.SYS
            ; --- ESXDOS FUNCTIONS
            define      M_GETSETDRV   $89
            define      F_OPEN        $9a
            define      F_CLOSE       $9b
            define      F_READ        $9d
            define      F_WRITE       $9e
            ; --- FILE OPEN MODES
            define      FA_READ       1
            define      FA_CREATE_AL  12

            ; --- AUTOEXEC.BIN data
            define      LOAD_ADDRESS      32768 ; Address where to load AUTOEXEC.BIN file
            define      LOAD_SIZE         32768 ; Size of the AUTOEXEC.BIN file (if size if larger than file, file is loaded anyway)
            define      START_ADDRESS     33768 ; Start address to run the game

            ; --- Place the stack at a proper place
            LD SP, LOAD_ADDRESS - 1
            ; --- Set default disk    
            xor a
            rst $08
            db M_GETSETDRV
            JR C, Error
            ; --- Open AUTOEXEC.BIN file at root folder
            ld b, FA_READ   
            ld HL, FileName   
            rst $08
            db F_OPEN      
            JR C, Error
      ; --- Load AUTOEXEC.BIN
            ld (FHandle),a
            ld HL, LOAD_ADDRESS
            ld bc, LOAD_SIZE
            rst $08
            db F_READ      ; read file
            JR C, Error
      ; --- Close file      
            ld a,(FHandle)
            rst $08
            db F_CLOSE
            JR C, Error

      ; --- Jump to entry address for the game, but passing trough 1FFAh so ESXDOS ROM is paged out (and back to normal Spectrum ROM)
            LD HL, START_ADDRESS
            PUSH HL
            JP 1FFAh

      ; --- On error, just freeze
Error       DI 
            HALT

      ; --- Variables and constants
FHandle           db 0
FileName          db 'AUTOEXEC.BIN', 0
